local originalBeginSession = BeginSession

-- Script by ArkaZ < arkaz@hotmail.fr >
-- Special thanks to the Phantom Mod Team for their code

local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')


function OnPopulate()
	ScenarioUtils.InitializeArmies()
end


function KillAllUnits(armyNumber)
	--PrintText('Player ' .. armyNumber .. ' has no more time', 20, nil, 10, 'leftcenter')
    local units = ArmyBrains[armyNumber]:GetListOfUnits( categories.ALLUNITS, false )
    for k,v in units do		
        v:OnKilled(nil,nil,nil)
    end
end

function TIRORemainingTime()
	while true do
		WaitSeconds(30)		
		if (ArmyBrains[GetFocusArmy()].totaltime) then
			timeleft = ArmyBrains[GetFocusArmy()].totaltime - GetGameTimeSeconds() 
		else
			timeleft = 0
		end
		minutes = math.floor(timeleft/60)
		seconds = math.floor(timeleft - (minutes * 60))
		if (seconds < 10)
		then
			seconds = 0 .. seconds
		end
		if (timeleft > 0) then			
			PrintText('Timeleft : ' .. minutes .. ':' .. seconds , 12, nil, 3, 'leftcenter')
		end
	end
end

function TIROMainThread()
	for index, brain in ArmyBrains do	 	
		brain.totaltime = 1800	
	end		
	
	PrintText('Warning ! You have ' .. math.floor(ArmyBrains[GetFocusArmy()].totaltime/60) .. ' minutes left', 20, nil, 10, 'leftcenter')
	PrintText('You will lose time when a unit you own is killed', 20, nil, 10, 'leftcenter')
	PrintText('You will gain time when you kill an enemy unit', 20, nil, 10, 'leftcenter')		
	
	while true do			
		for index, brain in ArmyBrains do
			if ArmyIsCivilian(index) == false and ArmyIsOutOfGame(index) == false then			 			
				timeleft = ArmyBrains[index].totaltime - GetGameTimeSeconds() 
				if (timeleft <= 0) then
					KillAllUnits(index)
				end
			end
		end
		WaitSeconds(1)	
	end
	
end


function OnStart()
	for index, brain in ArmyBrains do
		
		brain.CalculateScore = function(this_brain)
			if (this_brain.totaltime) then
				timeleft = this_brain.totaltime - GetGameTimeSeconds() 
			else
				timeleft = 0
			end	
			
			if (timeleft < 0) then 
				timeleft = 0 
			end
			
			return math.floor(timeleft)
		end
		
	end	

	local TIRO_main_thread = ForkThread(TIROMainThread)
	local TIRO_thread_remaining = ForkThread(TIRORemainingTime)
end


function BeginSession()
	originalBeginSession()
	OnStart()    
end